require 'statsd'

class Kstatsd
  
  def initialize(serverhost,serverport,enabled=true)
    if($statsd == nil)
      $statsd = Statsd.new serverhost,serverport
    end         
    $enabled = enabled
  end

  def increment(bucket, sr=1)
    $statsd.increment bucket,sr if $enabled == true    
  end
  
  def decrement(bucket, sr=1)
    $statsd.decrement bucket,sr if $enabled == true    
  end
  
  def timing(bucket,ms, sr=1)
    $statsd.timing bucket,ms,sr  if $enabled == true
  end
  
  def gauge (bucket, ms, sr=1)
    $statsd.gauge bucket, ms,sr if $enabled == true
  end

  def timeEnd(bucket,startTime, sr=1)
    $statsd.timing bucket, time_diff_milli(startTime),sr  if $enabled == true
  end

  def time (bucket,sr=1)
    $statsd.time(bucket,sr) { yield }  if $enabled == true  
  end
  
  def time_diff_milli(start)
    finish = Time.now
    return ((finish - start)* 1000.0).round  
  end
  
end